<template>
  <div :class="{top: top}">
    <sms-form :installment="showMessage"
              v-model="$user.smsCode"
              @change="handleSms"
              @resend="againSms"
              :timeOut="0"
              :placeHolder="false"
              ref="signingInstallment"
    >
      <template slot="title">
        <h3>Реструктуризация займа</h3>
      </template>
      <template slot="'additional-title'">
        <div class="warning-block" v-if="top">
          <b>Внимание</b>
          <br>Вам необходимо подписать доп.соглашение о рассрочке до {{$dayjs($pdl.supplementary.installment.signDateEnd).format('DD.MM.YYYY (HH:mm:ss)')}}
        </div>
        <p>Для подписания доп. соглашения о рассрочке введите код подтверждения из SMS.</p>
      </template>
      <template slot="'additional-button'">
        <button @click="signInstallment"
                v-if="top && showMessage"
                :disabled="agree || smsCode.length < 4"
                :class="{button_loading: loading}"
                class="bottom"
        >
          Подписать
        </button>
      </template>
      <template slot="agreement">
        <div class="checkbox">
          <input type="checkbox"
                 name="contract-agree"
                 id="contract-agree"
                 v-model="condition"
                 v-validate="'required'"
                 @click="condition === false ? agree = false : agree = true"
          >

          <label for="contract-agree">
            <span></span>Вводя код подтверждения, вы принимаете
            <a @click.prevent.stop="documentIsInstallment">условия доп. соглашения.</a>
          </label>
        </div>
      </template>
    </sms-form>

  </div>
</template>

<script>
  import ValidateMessage from '@/components/Validators/ValidateMessage'
  import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'
  import SuccessMessage from '@/components/AuxiliaryWindows/SuccessMessage'
  import {errorInstallment} from '@/utils/error/installment'
  import loader from '@/base/Loader'
  import Vue from 'vue'
  import SmsForm from '@/components/SmsForm'


  export default {
    name: 'SignInstallment',
    mixins: [
      GetValidateClass
    ],
    components: {
      ValidateMessage,
      SuccessMessage,
      SmsForm
    },
    props: {
      top: {
        type: Boolean,
        default: false
      }
    },
    data () {
      return {
        smsCode: '',
        condition: true,
        agree: false,
        showMessage: true,
        err: '',
        actived: false,
        loading: false,
        contact: ''
      }
    },
    methods: {
      handleSms (sms) {
        this.smsCode = sms;
      },
      signInstallment () {
        let sms = Number(this.smsCode)
        if (sms >= 1000) {
          this.loading = true
          this.agree = true
          this.$backend.api.supplementary.installment.sign(sms)
            .then(() => {
              this.showMessage = false
              this.$toastr.success('Доп. соглашение о рассрочке успешно подписано', 'Успешно')
              this.$store.dispatch('GET_LOAN_PDL').then(() => {
                let amount = this.$pdl.supplementary.installment.depositAmount;
                if (this.$posServices) {
                  amount += this.$posServices.sumLeft;
                }
                this.$store.commit('SET_PAYMENT', {
                  type: 'installment_deposit',
                  amount
                })
              })
            })
            .catch((error) => {
              this.$toastr.error(this.getErrorText(error), 'Ошибка')
              this.err = errorInstallment(error.errors[0].code)
              this.actived = true
              this.loading = false
              this.agree = false
            })
        } else {
          this.err = 'СМС-код введен не корректно'
          this.$toastr.error(this.err, 'Ошибка')
          this.actived = true
        }
      },
      getErrorText (error) {
        const errors = {
          mobilePhoneDoNotHaveActiveSmsCode: 'Ошибка отправки смс-кода.'
        }
        if (error.errors && error.errors.length) {
          return errors[error.errors[0].code]
        }
      },
      againSms () {
        this.$backend.api.supplementary.installment.resend()
          .then(() => {
            this.$toastr.success('СМС-код был выслан повторно')
            // this.tiktak()
          })
          .catch((error) => {
            this.err = errorInstallment(error.errors[0].code)
            this.error = true
            this.$toastr.error(errorInstallment(error.errors[0].code))
          })
      },
      clearError () {
        this.err = ''
        this.actived = false
      },
      async documentIsInstallment () {
        const win = window.open('about:blank', '_blank', 'width=1024,height=600')
        this.createLoader(win)
        this.$backend.api.documents.byUrl(`supplementary/html/${this.$pdl.id}/last`).then(({data}) => {
          win.document.documentElement.innerHTML = data
        }).catch((e) => {
          console.warn(e);
          this.$toastr.error('Не удалось загрузить документ', 'Ошибка');
        })

      },
      createLoader (win) {
        const body = win.document.body
        const Component = Vue.extend(loader)
        const element = new Component().$mount().$el
        body.appendChild(element)
        const style = document.createElement('style')
        style.setAttribute('type', 'text/css')
        // не нужно пугаться этого ужаса
        style.innerText = `#floatingCirclesG{
    position:relative;
    width:125px;
    height:125px;
    margin:auto;
    transform:scale(0.6);
    -o-transform:scale(0.6);
    -ms-transform:scale(0.6);
    -webkit-transform:scale(0.6);
    -moz-transform:scale(0.6);
  }

  .f_circleG{
    position:absolute;
    background-color:rgb(255,255,255);
    height:22px;
    width:22px;
    border-radius:12px;
    -o-border-radius:12px;
    -ms-border-radius:12px;
    -webkit-border-radius:12px;
    -moz-border-radius:12px;
    animation-name:f_fadeG;
    -o-animation-name:f_fadeG;
    -ms-animation-name:f_fadeG;
    -webkit-animation-name:f_fadeG;
    -moz-animation-name:f_fadeG;
    animation-duration:1.2s;
    -o-animation-duration:1.2s;
    -ms-animation-duration:1.2s;
    -webkit-animation-duration:1.2s;
    -moz-animation-duration:1.2s;
    animation-iteration-count:infinite;
    -o-animation-iteration-count:infinite;
    -ms-animation-iteration-count:infinite;
    -webkit-animation-iteration-count:infinite;
    -moz-animation-iteration-count:infinite;
    animation-direction:normal;
    -o-animation-direction:normal;
    -ms-animation-direction:normal;
    -webkit-animation-direction:normal;
    -moz-animation-direction:normal;
  }

  #frotateG_01{
    left:0;
    top:51px;
    animation-delay:0.45s;
    -o-animation-delay:0.45s;
    -ms-animation-delay:0.45s;
    -webkit-animation-delay:0.45s;
    -moz-animation-delay:0.45s;
  }

  #frotateG_02{
    left:15px;
    top:15px;
    animation-delay:0.6s;
    -o-animation-delay:0.6s;
    -ms-animation-delay:0.6s;
    -webkit-animation-delay:0.6s;
    -moz-animation-delay:0.6s;
  }

  #frotateG_03{
    left:51px;
    top:0;
    animation-delay:0.75s;
    -o-animation-delay:0.75s;
    -ms-animation-delay:0.75s;
    -webkit-animation-delay:0.75s;
    -moz-animation-delay:0.75s;
  }

  #frotateG_04{
    right:15px;
    top:15px;
    animation-delay:0.9s;
    -o-animation-delay:0.9s;
    -ms-animation-delay:0.9s;
    -webkit-animation-delay:0.9s;
    -moz-animation-delay:0.9s;
  }

  #frotateG_05{
    right:0;
    top:51px;
    animation-delay:1.05s;
    -o-animation-delay:1.05s;
    -ms-animation-delay:1.05s;
    -webkit-animation-delay:1.05s;
    -moz-animation-delay:1.05s;
  }

  #frotateG_06{
    right:15px;
    bottom:15px;
    animation-delay:1.2s;
    -o-animation-delay:1.2s;
    -ms-animation-delay:1.2s;
    -webkit-animation-delay:1.2s;
    -moz-animation-delay:1.2s;
  }

  #frotateG_07{
    left:51px;
    bottom:0;
    animation-delay:1.35s;
    -o-animation-delay:1.35s;
    -ms-animation-delay:1.35s;
    -webkit-animation-delay:1.35s;
    -moz-animation-delay:1.35s;
  }

  #frotateG_08{
    left:15px;
    bottom:15px;
    animation-delay:1.5s;
    -o-animation-delay:1.5s;
    -ms-animation-delay:1.5s;
    -webkit-animation-delay:1.5s;
    -moz-animation-delay:1.5s;
  }



  @keyframes f_fadeG{
    0%{
      background-color:rgb(0,0,0);
    }

    100%{
      background-color:rgb(255,255,255);
    }
  }

  @-o-keyframes f_fadeG{
    0%{
      background-color:rgb(0,0,0);
    }

    100%{
      background-color:rgb(255,255,255);
    }
  }

  @-ms-keyframes f_fadeG{
    0%{
      background-color:rgb(0,0,0);
    }

    100%{
      background-color:rgb(255,255,255);
    }
  }

  @-webkit-keyframes f_fadeG{
    0%{
      background-color:rgb(0,0,0);
    }

    100%{
      background-color:rgb(255,255,255);
    }
  }

  @-moz-keyframes f_fadeG{
    0%{
      background-color:rgb(0,0,0);
    }

    100%{
      background-color:rgb(255,255,255);
    }
  }`
        win.document.querySelector('head').appendChild(style)
      }
    },
    mounted () {
      if (this.showMessage === true) {
        this.$refs.sms.focus();
        this.$helpers.scroll(this.$refs.signingInstallment.$el);
        // this.tiktak()
      }

      this.$on('focus', () => {
        this.$refs.sms.focus();
      })
    }
  }
</script>

<style scoped lang="scss">
  @import "static/css/variables/main";

  .top {
    border-bottom: 1px solid #e1e1e1;
    margin-bottom: 40px;
    & button.bottom {
      position: relative;
      bottom: 0;
    }

    & .message {
      display: flex;
      align-items: flex-end;
      flex-wrap: wrap;
      .columns {
        &.button {
          padding-left: 0;
          margin-bottom: 0;
          & button {
            height: 40px;
            margin-bottom: 15px;
            line-height: 40px;

            @media #{$mobile} {
              margin-top: 20px;
            }
          }
        }
      }
    }
  }
</style>
